%  Plot overfringsfunktionen for filteret
%
%  version 1.1, 5/2-2003, JAJ
%  version 1.2, 31/1-2006, JAJ
%     Fejl i legends rettet

function ans = plot_spektre (signal,impuls,hp1,hp2,hp3)

%  Beregn spektrene

fs=25;
dft_sig=fftshift(abs(fft(signal, 1024)));
dft_ovr=fftshift(abs(fft(impuls, 1024)));
dft_res=fftshift(abs(fft(conv(signal,impuls)/fs, 1024)));
faktor = max([dft_res dft_sig dft_ovr]);

%  Plot spektret af indgangssignalet

axes(hp1)
plot(dft_sig,'r')
axis([256 768 0 max(dft_sig)*1.1])
title('Spektrum for indgangssignal')
set(hp1,'Xticklabel','','Yticklabel','')

%  Plot overfoeringsfunktionen

axes(hp3)
plot(dft_ovr,'g')
axis([256 768 0 max(dft_ovr)*1.1])
title('Overfringsfunktion for filter')
set(hp3,'Xticklabel','','Yticklabel','')

%  Plot spektret af resultatet, indgangssignalet og overfringsfunktionen

axes(hp2)
cla
plot(1:1024,dft_res,'b',1:1024,dft_sig,'r',1:1024,dft_ovr,'g')
legend('Resultat','Signal ind','Overfringsfkt.')
axis([256 768 0 faktor*1.1])
title('Spektrum for indgangssignal')
set(hp2,'Xticklabel','','Yticklabel','')
zoom on

